// Code generated by protoc-gen-gogo. DO NOT EDIT.
// source: service.proto

package pb_demo

import (
	context "context"
	fmt "fmt"
	_ "github.com/gogo/protobuf/gogoproto"
	proto "github.com/gogo/protobuf/proto"
	types "github.com/gogo/protobuf/types"
	golang_proto "github.com/golang/protobuf/proto"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	math "math"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = golang_proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.GoGoProtoPackageIsVersion3 // please upgrade the proto package

func init() { proto.RegisterFile("service.proto", fileDescriptor_a0b84a42fa06f626) }
func init() { golang_proto.RegisterFile("service.proto", fileDescriptor_a0b84a42fa06f626) }

var fileDescriptor_a0b84a42fa06f626 = []byte{
	// 293 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x74, 0x90, 0x4f, 0x4a, 0xc4, 0x30,
	0x14, 0xc6, 0xa7, 0x28, 0x3a, 0xa4, 0x88, 0x10, 0x44, 0xb4, 0x95, 0x2a, 0xb3, 0x37, 0x05, 0x3d,
	0xc1, 0x48, 0xa5, 0x20, 0xe2, 0x42, 0xd1, 0xfd, 0x74, 0xe6, 0x4d, 0x2c, 0xb4, 0xbe, 0xd8, 0xa4,
	0x8a, 0x37, 0xf2, 0x16, 0xba, 0x74, 0xe9, 0x11, 0xa4, 0x5e, 0x44, 0xda, 0x34, 0x69, 0x71, 0x3a,
	0xbb, 0x7e, 0x7f, 0xfa, 0x4b, 0xf2, 0x91, 0x1d, 0x09, 0xc5, 0x4b, 0x3a, 0x07, 0x26, 0x0a, 0x54,
	0x48, 0xb7, 0x45, 0xc2, 0x16, 0x90, 0xa3, 0xe7, 0x73, 0x44, 0x9e, 0x41, 0xd8, 0xd8, 0x49, 0xb9,
	0x0c, 0x21, 0x17, 0xea, 0x4d, 0xb7, 0xbc, 0x53, 0x9e, 0xaa, 0xc7, 0x32, 0x61, 0x73, 0xcc, 0x43,
	0x8e, 0x1c, 0xbb, 0x56, 0xad, 0x1a, 0xd1, 0x7c, 0xb5, 0x75, 0x97, 0x17, 0x58, 0x0a, 0x2d, 0xce,
	0x3e, 0x36, 0xc8, 0x66, 0x04, 0x39, 0xd2, 0x29, 0x19, 0xdf, 0xc0, 0x6b, 0x5c, 0x47, 0xf4, 0x80,
	0xb5, 0xe7, 0x32, 0x63, 0xdd, 0xc2, 0x73, 0x09, 0x52, 0x79, 0x87, 0x03, 0x89, 0x14, 0xf8, 0x24,
	0x61, 0x32, 0xa2, 0x57, 0xc4, 0xbd, 0x17, 0x8b, 0x99, 0x02, 0x4d, 0xf1, 0x6d, 0xb7, 0xe7, 0x1a,
	0xd0, 0xd1, 0x70, 0x68, 0x59, 0x11, 0x71, 0x23, 0xc8, 0x60, 0x95, 0xd5, 0x73, 0x0d, 0x6b, 0x9f,
	0xe9, 0x75, 0x98, 0x79, 0x37, 0xbb, 0xac, 0xd7, 0x99, 0x8c, 0x68, 0x4c, 0xc8, 0x75, 0x2a, 0x55,
	0xd3, 0x96, 0xd4, 0xb3, 0x90, 0xce, 0x34, 0x0c, 0x7f, 0x30, 0xb3, 0xd7, 0x79, 0x20, 0xbb, 0x77,
	0xa0, 0xed, 0x08, 0x96, 0xb3, 0x32, 0x53, 0xf4, 0xd8, 0xfe, 0xf1, 0x2f, 0x31, 0xc8, 0x93, 0xf5,
	0x05, 0xcb, 0x9d, 0x92, 0x71, 0xdc, 0x86, 0xbd, 0xd5, 0x8d, 0xb5, 0xba, 0x7a, 0x97, 0x18, 0xc4,
	0xc5, 0xde, 0x7b, 0x15, 0x38, 0x5f, 0x55, 0xe0, 0x7c, 0x57, 0x81, 0xf3, 0x53, 0x05, 0xce, 0xe7,
	0x6f, 0xe0, 0x24, 0x5b, 0xcd, 0x16, 0xe7, 0x7f, 0x01, 0x00, 0x00, 0xff, 0xff, 0xd7, 0xb0, 0xd4,
	0x4d, 0x51, 0x02, 0x00, 0x00,
}

// Reference imports to suppress errors if they are not otherwise used.
var _ context.Context
var _ grpc.ClientConn

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
const _ = grpc.SupportPackageIsVersion4

// DemoClient is the client API for Demo service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://godoc.org/google.golang.org/grpc#ClientConn.NewStream.
type DemoClient interface {
	// Create a new Group
	NewGroup(ctx context.Context, in *NewGroupRequest, opts ...grpc.CallOption) (*NewGroupResponse, error)
	// Update group
	UpdateGroup(ctx context.Context, in *UpdateGroupRequest, opts ...grpc.CallOption) (*UpdateGroupResponse, error)
	// Remove group
	DeleteGroup(ctx context.Context, in *DeleteGroupRequest, opts ...grpc.CallOption) (*types.Empty, error)
	// Get list groups
	// returns the list of group you're in
	ListGroups(ctx context.Context, in *ListGroupsRequest, opts ...grpc.CallOption) (*ListGroupsResponse, error)
	// Set group default
	SetGroupDefault(ctx context.Context, in *SetGroupDefaultRequest, opts ...grpc.CallOption) (*SetGroupDefaultResponse, error)
	// Get group info
	GetGroup(ctx context.Context, in *GetGroupRequest, opts ...grpc.CallOption) (*GetGroupResponse, error)
}

type demoClient struct {
	cc *grpc.ClientConn
}

func NewDemoClient(cc *grpc.ClientConn) DemoClient {
	return &demoClient{cc}
}

func (c *demoClient) NewGroup(ctx context.Context, in *NewGroupRequest, opts ...grpc.CallOption) (*NewGroupResponse, error) {
	out := new(NewGroupResponse)
	err := c.cc.Invoke(ctx, "/pb.demo.Demo/NewGroup", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *demoClient) UpdateGroup(ctx context.Context, in *UpdateGroupRequest, opts ...grpc.CallOption) (*UpdateGroupResponse, error) {
	out := new(UpdateGroupResponse)
	err := c.cc.Invoke(ctx, "/pb.demo.Demo/UpdateGroup", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *demoClient) DeleteGroup(ctx context.Context, in *DeleteGroupRequest, opts ...grpc.CallOption) (*types.Empty, error) {
	out := new(types.Empty)
	err := c.cc.Invoke(ctx, "/pb.demo.Demo/DeleteGroup", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *demoClient) ListGroups(ctx context.Context, in *ListGroupsRequest, opts ...grpc.CallOption) (*ListGroupsResponse, error) {
	out := new(ListGroupsResponse)
	err := c.cc.Invoke(ctx, "/pb.demo.Demo/ListGroups", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *demoClient) SetGroupDefault(ctx context.Context, in *SetGroupDefaultRequest, opts ...grpc.CallOption) (*SetGroupDefaultResponse, error) {
	out := new(SetGroupDefaultResponse)
	err := c.cc.Invoke(ctx, "/pb.demo.Demo/SetGroupDefault", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *demoClient) GetGroup(ctx context.Context, in *GetGroupRequest, opts ...grpc.CallOption) (*GetGroupResponse, error) {
	out := new(GetGroupResponse)
	err := c.cc.Invoke(ctx, "/pb.demo.Demo/GetGroup", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// DemoServer is the server API for Demo service.
type DemoServer interface {
	// Create a new Group
	NewGroup(context.Context, *NewGroupRequest) (*NewGroupResponse, error)
	// Update group
	UpdateGroup(context.Context, *UpdateGroupRequest) (*UpdateGroupResponse, error)
	// Remove group
	DeleteGroup(context.Context, *DeleteGroupRequest) (*types.Empty, error)
	// Get list groups
	// returns the list of group you're in
	ListGroups(context.Context, *ListGroupsRequest) (*ListGroupsResponse, error)
	// Set group default
	SetGroupDefault(context.Context, *SetGroupDefaultRequest) (*SetGroupDefaultResponse, error)
	// Get group info
	GetGroup(context.Context, *GetGroupRequest) (*GetGroupResponse, error)
}

// UnimplementedDemoServer can be embedded to have forward compatible implementations.
type UnimplementedDemoServer struct {
}

func (*UnimplementedDemoServer) NewGroup(ctx context.Context, req *NewGroupRequest) (*NewGroupResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method NewGroup not implemented")
}
func (*UnimplementedDemoServer) UpdateGroup(ctx context.Context, req *UpdateGroupRequest) (*UpdateGroupResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdateGroup not implemented")
}
func (*UnimplementedDemoServer) DeleteGroup(ctx context.Context, req *DeleteGroupRequest) (*types.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DeleteGroup not implemented")
}
func (*UnimplementedDemoServer) ListGroups(ctx context.Context, req *ListGroupsRequest) (*ListGroupsResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ListGroups not implemented")
}
func (*UnimplementedDemoServer) SetGroupDefault(ctx context.Context, req *SetGroupDefaultRequest) (*SetGroupDefaultResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method SetGroupDefault not implemented")
}
func (*UnimplementedDemoServer) GetGroup(ctx context.Context, req *GetGroupRequest) (*GetGroupResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetGroup not implemented")
}

func RegisterDemoServer(s *grpc.Server, srv DemoServer) {
	s.RegisterService(&_Demo_serviceDesc, srv)
}

func _Demo_NewGroup_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(NewGroupRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(DemoServer).NewGroup(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/pb.demo.Demo/NewGroup",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(DemoServer).NewGroup(ctx, req.(*NewGroupRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Demo_UpdateGroup_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UpdateGroupRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(DemoServer).UpdateGroup(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/pb.demo.Demo/UpdateGroup",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(DemoServer).UpdateGroup(ctx, req.(*UpdateGroupRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Demo_DeleteGroup_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(DeleteGroupRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(DemoServer).DeleteGroup(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/pb.demo.Demo/DeleteGroup",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(DemoServer).DeleteGroup(ctx, req.(*DeleteGroupRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Demo_ListGroups_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ListGroupsRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(DemoServer).ListGroups(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/pb.demo.Demo/ListGroups",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(DemoServer).ListGroups(ctx, req.(*ListGroupsRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Demo_SetGroupDefault_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(SetGroupDefaultRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(DemoServer).SetGroupDefault(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/pb.demo.Demo/SetGroupDefault",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(DemoServer).SetGroupDefault(ctx, req.(*SetGroupDefaultRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Demo_GetGroup_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetGroupRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(DemoServer).GetGroup(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/pb.demo.Demo/GetGroup",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(DemoServer).GetGroup(ctx, req.(*GetGroupRequest))
	}
	return interceptor(ctx, in, info, handler)
}

var _Demo_serviceDesc = grpc.ServiceDesc{
	ServiceName: "pb.demo.Demo",
	HandlerType: (*DemoServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "NewGroup",
			Handler:    _Demo_NewGroup_Handler,
		},
		{
			MethodName: "UpdateGroup",
			Handler:    _Demo_UpdateGroup_Handler,
		},
		{
			MethodName: "DeleteGroup",
			Handler:    _Demo_DeleteGroup_Handler,
		},
		{
			MethodName: "ListGroups",
			Handler:    _Demo_ListGroups_Handler,
		},
		{
			MethodName: "SetGroupDefault",
			Handler:    _Demo_SetGroupDefault_Handler,
		},
		{
			MethodName: "GetGroup",
			Handler:    _Demo_GetGroup_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "service.proto",
}
